Global NomeMoto$
   'Contiene il nome dei file che descrivono la moto in esame
   'senza path e senza estensione.
Global ProgDir$
   'Directory da cui  stato avviato il programma. Termina sempre con "\".

'---------------------------------------------------------------------------------
'I dati elencati nella sezione seguente vengono definiti durante la Sub File_Open
'e mantenuti sempre aggiornati durante tutta l'esecuzione del programma.
'---------------------------------------------------------------------------------
Global TotKm&
   'Contiene il chilometraggio totale della moto
   'escluse le centinaia di metri.
Global DataPrimaImm$
   'Contiene la data di prima immatricolazione della moto.
Global NumeroServizi%
   'Numero dei servizi di manutenzione contenuti nel file dei servizi.
Global Dati$()
   'Contiene tutti i dati del programma di manutenzione.
   'Ha dimensioni Dati$(0 To 13, 1 To NumeroServizi%) e la seguente struttura:
   'Dati$(0, i%) Nome dell'i-esimo servizio
   'Dati$(1, i%) Nome del primo intervento di manutenzione dell'i-esimo servizio
   'Dati$(2, i%) Intervallo in km del primo intervento
   'Dati$(3, i%) Intervallo in giorni del primo intervento
   'Dati$(4, i%) Nome del secondo intervento di manutenzione dell'i-esimo servizio
   'Dati$(5, i%) ...
   'Dati$(6, i%) ...
   '...
   '...
   'Dati$(13, i%) Elenco degli interventi effettuati (un'unica stringa)
'---------------------------------------------------------------------------------
Global Const FileBmp = "MOTO.BMP"
Global Const FileIni = "MOTO.INI"
Global Const ExtDat = ".DAT"
Global Const ExtSer = ".SER"
Global Const ExtBmp = ".BMP"
Global Const ExtTmp = ".~TM"
Global Const Tagged$ = "> "
Global Const EndOfOper$ = "***"
Global Const DateForm$ = "d-mmm-yyyy"
Global Const KmForm$ = "00000"
Global Const Salva$ = "Salvare le modifiche effettuate?"
Global Const Abbandona$ = "Abbandonare le modifiche effettuate?"

Sub Crea_Prototipi ()
   'Crea i prototipi dei tre file: per i dati, per i servizi e per l'immagine.
   'Riceve la Global NomeMoto$ per sapere il nome da dare ai file.
   MousePointer = 11
   'Crea un file dei dati vuoto.
   f% = FreeFile
   Open NomeMoto$ & ExtDat For Output As #f%
   For n% = 1 To 9
      Print #f%, ""
   Next n%
   Close #f%
   'Crea il prototipo di un file dei servizi con una sola voce.
   Open NomeMoto$ & ExtSer For Output As #f%
   Riga$ = Format$(Now - 250, DateForm$) & ", " & Format$(0, KmForm$)
   Print #f%, 1
   Print #f%, "Esempio di servizio"
   Print #f%, "Controllo,3000,90": Print #f%, Riga$: Print #f%, EndOfOper$
   Print #f%, "Lubrificazione,6000,180": Print #f%, Riga$: Print #f%, EndOfOper$
   Print #f%, "Pulizia,12000,365": Print #f%, Riga$: Print #f%, EndOfOper$
   Print #f%, "Sostituzione,36000,1095": Print #f%, Riga$: Print #f%, EndOfOper$
   Close #f%
   'Crea un nuovo file per contenere il logo della moto.
   FileCopy ProgDir & FileBmp, NomeMoto$ & ExtBmp
   MousePointer = 0
   msg$ = "Sono stati creati tre nuovi file: " & NomeMoto$ & ExtDat & ", " & NomeMoto$ & ExtSer & " e " & NomeMoto$ & ExtBmp & ". In essi sono memorizzati i dati della nuova moto. "
   msg$ = msg$ & "Il file " & ExtBmp & " pu essere modificato per contenere un'immagine relativa alla moto aggiunta."
   title$ = "Aggiunta un'altra moto"
   MsgBox msg$, 64, title$
End Sub

Function Exist% (FileSpec$)
   'Ritorna True se FileSpec$ esiste, False altrimenti.
   f% = FreeFile
   On Error Resume Next
   Open FileSpec$ For Input As f%
   If Err Then
      Exist% = False
   Else
      Close f%
      Exist% = True
   End If
   On Error GoTo 0
End Function

Sub File_Open ()
   'Riceve nella Global NomeMoto$ il nome della moto da aprire e
   'setta tutte le variabili relative:
   '    Global TotKm&
   '    Global DataPrimaImm$
   '    Global NumeroServizi%
   '    Global Dati$()
   'Recupera dal file dei dati il chilometraggio totale e la data di prima immatricolazione.
   MousePointer = 11
   f% = FreeFile: Open NomeMoto$ & ExtDat$ For Input As #f%
   ReDim Riga$(0 To 7)
   For n% = 0 To 7
      Input #f%, Riga$(n%)
   Next n%
   Close #f%
   TotKm& = Val(Riga$(0))
   If IsDate(Riga$(7)) Then
      DataPrimaImm$ = Format$(Riga$(7), DateForm$)
   Else
      DataPrimaImm$ = Format$(0, DateForm$)
   End If
   'Chiama la Sub Leggi_Dati per settare NumeroServizi% e Dati$()
   Leggi_Dati
   'Mostra l'immagine relativa alla moto e abilita il menu Dati.
   MotoCiclo.Logo.Picture = LoadPicture(NomeMoto$ & ExtBmp)
   MotoCiclo.M_Dati.Enabled = True
   'Scrive il file .INI.
   f% = FreeFile: Open ProgDir$ & FileIni For Output As #f%
   Print #f%, NomeMoto$
   Close #f%
   MousePointer = 0
End Sub

Sub Get_Next_Inter (Servizio%, Start%, EsecData$, EsecKm&)
   'Restituisce in EsecData$ e in EsecKm& una data e il relativo chilometraggio
   'presi dalla cronologia di Servizio%.
   'Se Start% = 1 viene restituita la prima data disponibile del primo intervento,
   'per le chiamate successive non alterare Start%.
   'Se non trova altre date relative all'intervento in esame restituisce i valori:
   'EsecKm& = 0 ed EsecData$ = DataPrimaImm$
   'Quindi l'intera cronologia di Servizio% termina dopo aver trovato per la quarta
   'volta questi valori.
   Found% = InStr(Start%, Dati$(13, Servizio%), Chr$(13))
   Riga$ = Mid$(Dati$(13, Servizio%), Start%, Found% - Start%)
   Start% = Found% + 1
   If Riga$ <> EndOfOper$ Then
      i% = InStr(Riga$, ",")
      EsecData$ = LTrim$(RTrim$(Left$(Riga$, i% - 1)))
      EsecKm& = Val(Mid$(Riga$, i% + 1))
   Else
      EsecData$ = DataPrimaImm$
      EsecKm& = 0
   End If
End Sub

Sub Leggi_Dati ()
   'Carica tutto il contenuto del file dei servizi nella matrice Dati$().
   MousePointer = 11
   'Legge il numero dei servizi.
   f% = FreeFile: Open NomeMoto & ExtSer For Input As #f%
   Line Input #f%, Riga$
   NumeroServizi% = Val(Riga$)
   'Ridimensiona la matrice Dati$() per contenere i dati della manutenzione.
   ReDim Dati$(0 To 13, 1 To NumeroServizi%)
   For i% = 1 To NumeroServizi%
      Line Input #f%, Dati(0, i%)
      For n% = 0 To 3
         Input #f%, Dati$(1 + n% * 3, i%), Dati$(2 + n% * 3, i%), Dati$(3 + n% * 3, i%)
         Do: Line Input #f%, Riga$
            Dati$(13, i%) = Dati$(13, i%) & Riga$ & Chr$(13)
         Loop While Riga$ <> EndOfOper$
      Next n%
   Next i%
   Close #f%
   'Ordina alfabeticamente la matrice Dati$().
   Simple_Sort Dati$(), 0, 13, 1, NumeroServizi%, 0
   MousePointer = 0
End Sub

Sub Scrivi_Dati ()
   'Salva tutto il contenuto della matrice Dati$() nel file dei servizi.
   MousePointer = 11
   f% = FreeFile: Open NomeMoto$ & ExtSer For Output As #f%
   Print #f%, NumeroServizi%
   For i% = 1 To NumeroServizi%
      Print #f%, Dati$(0, i%)
      Start% = 1
      For n% = 0 To 3
         Print #f%, Dati$(1 + n% * 3, i%) & "," & Dati$(2 + n% * 3, i%) & "," & Dati$(3 + n% * 3, i%)
         Do: Found% = InStr(Start%, Dati$(13, i%), Chr$(13))
            Riga$ = Mid$(Dati$(13, i%), Start%, Found% - Start%)
            Start% = Found% + 1
            Print #f%, Riga$
         Loop While Riga$ <> EndOfOper$
      Next n%
   Next i%
   Close #f%
   MousePointer = 0
End Sub

Sub Simple_Sort (M$(), LowRiga%, Righe%, LowColonna%, Colonne%, Campo%)
   'Ordina alfabeticamente (per colonne) la matrice di stringhe M$.
   'LowRiga%    indice inferiore delle righe.
   'LowColonna% indice inferiore delle colonne.
   'Righe%      numero delle righe da considerare.
   'Colonne%    numero delle colonne da considerare.
   'Campo%      riga sulla quale si effettua l'ordinamento.
   For i% = LowColonna% To Colonne% - 1
      For j% = i% + 1 To Colonne%
         If M$(Campo%, j%) < M$(Campo%, i%) Then
            For k% = LowRiga% To Righe%
               Tmp$ = M(k%, j%)
               M$(k%, j%) = M$(k%, i%)
               M$(k%, i%) = Tmp$
            Next k%
         End If
      Next j%
   Next i%
End Sub

